#include "device.h"
/***************************************************************************************************************************/

unsigned char EzKIT_SwitchConfig[] =
{
/*     U40 Port A                                  U40 Port B
  7--------------- ~UART0CTS_RST_EN       |       7---------------  EMPTY
  | 6------------- ~UART0CTS_RTS_LPBK     |       | 6------------- ~LED4_GPIO4_EN
  | | 5----------- ~UART0CTS_EN           |       | | 5----------- ~LED3_GPIO3_EN
  | | | 4--------- ~UART0RX_EN            |       | | | 4--------- ~LED2_GPIO2_EN
  | | | | 3------- ~UART0RTS_EN           |       | | | | 3------- ~LED1_GPIO1_EN
  | | | | | 2----- ~SPI0D3_EN             |       | | | | | 2----- ~PUSHBUTTON2_EN
  | | | | | | 1--- ~SPI0D2_EN             |       | | | | | | 1--- ~PUSHBUTTON1_EN
  | | | | | | | 0- ~SPIFLASH_CS_EN        |       | | | | | | | 0- ~CAN0_EN
  | | | | | | | |                         |       | | | | | | | |
  1 1 0 0 1 0 0 0                         |       1 0 0 0 0 0 0 1     ( value being set )*/
		0xC8,											0x81u,

/*       U41 Port A                                    U41 Port B
    7--------------- ~WAKE_PUSHBUTTON_EN  |       7---------------  EMPTY
    | 6-------------  RMII_CLK_EN         |       | 6-------------  EMPTY
    | | 5----------- ~PHYINT_EN           |       | | 5----------- ~SRAM_BYTE_EN
    | | | 4--------- ~ETHERNET_EN         |       | | | 4--------- ~ETH_EXP_EN 
    | | | | 3------- ~ETH0_MDIO_BUS_EN    |       | | | | 3------- ~PB_08_09_EXP_EN 
    | | | | | 2----- ~CAN1_EN             |       | | | | | 2----- ~TRACE_EXP_EN 
    | | | | | | 1---  RS485_DE            |       | | | | | | 1--- ~DATA_HIGH_EXP_EN
    | | | | | | | 0- ~RS485_RE            |       | | | | | | | 0- ~DATA_LOW_EXP_EN
    | | | | | | | |                       |       | | | | | | | |
    1 1 1 1 1 1 1 1                       |       1 1 1 1 0 1 1 1     ( value being set )*/
		0xFF, 											0xF7
};
/***************************************************************************************************************************/


void Init_EzKIT_SoftConfig(void)
{
  	unsigned char count=0, DIR_OUT =0;
	unsigned char EZKIT_SoftConfig1 = 0x20, EZKIT_SoftConfig2 = 0x21;

	Write_TWI_8bit_Reg(EZKIT_SoftConfig1, 0x14, &EzKIT_SwitchConfig[count++], 1);
	Write_TWI_8bit_Reg(EZKIT_SoftConfig1, 0x15, &EzKIT_SwitchConfig[count++], 1);
	Write_TWI_8bit_Reg(EZKIT_SoftConfig2, 0x14, &EzKIT_SwitchConfig[count++], 1);
	Write_TWI_8bit_Reg(EZKIT_SoftConfig2, 0x15, &EzKIT_SwitchConfig[count++], 1);

	Write_TWI_8bit_Reg(EZKIT_SoftConfig1, 0x00, &DIR_OUT, 1);
	Write_TWI_8bit_Reg(EZKIT_SoftConfig1, 0x01, &DIR_OUT, 1);
	Write_TWI_8bit_Reg(EZKIT_SoftConfig2, 0x00, &DIR_OUT, 1);
	Write_TWI_8bit_Reg(EZKIT_SoftConfig2, 0x01, &DIR_OUT, 1);
//	__builtin_ssync();
}
/***************************************************************************************************************************/


void Init_TWI0(void)
{
    *pREG_TWI0_CTL 		= 0x00;  					// Reset the TWI controller
	*pREG_TWI0_MSTRCTL 	= 0;
	*pREG_TWI0_MSTRSTAT = ( ENUM_TWI_MSTRSTAT_BUFWRERR_YES | ENUM_TWI_MSTRSTAT_BUFRDERR_YES | ENUM_TWI_MSTRSTAT_DNAK_YES | 
						    ENUM_TWI_MSTRSTAT_ANAK_YES | ENUM_TWI_MSTRSTAT_LOSTARB_YES );
	*pREG_TWI0_ISTAT 	=  	0xFF;				//	Clearing all pending interrupt flags
    *pREG_TWI0_FIFOCTL 	= ( ENUM_TWI_FIFOCTL_RXFLUSH | ENUM_TWI_FIFOCTL_TXFLUSH );
	*pREG_TWI0_CTL		= 	BITM_TWI_CTL_EN | ((10 << BITP_TWI_CTL_PRESCALE) & BITM_TWI_CTL_PRESCALE);
	*pREG_TWI0_CLKDIV	= 	( ((0x64 << BITP_TWI_CLKDIV_CLKHI) & BITM_TWI_CLKDIV_CLKHI) |
							  ((0x64 << BITP_TWI_CLKDIV_CLKLO) & BITM_TWI_CLKDIV_CLKLO) );
	*pREG_TWI0_FIFOCTL	= 	ENUM_TWI_FIFOCTL_TXONEBYTE | ENUM_TWI_FIFOCTL_RXTWOBYTE;
}
/**********************************************************************************************************************************/


void Write_TWI_8bit_Reg(unsigned char CHIP_ID, unsigned char Reg_ID, unsigned char* Tx_Buff, unsigned char count)
{
	*pREG_TWI0_MSTRADDR = CHIP_ID;
	unsigned char i;
	*pREG_TWI0_TXDATA8 = (Reg_ID & 0xFF);

	*pREG_TWI0_MSTRCTL = ((count+1) << 6) | ENUM_TWI_MSTRCTL_TX | BITM_TWI_MSTRCTL_EN;
	for(i=0; i<(count); i++)
	{
		while(!(*pREG_TWI0_ISTAT &	BITM_TWI_ISTAT_TXSERV));
		*pREG_TWI0_TXDATA8 = (*Tx_Buff++ & 0xFF);
		*pREG_TWI0_ISTAT |= 	BITM_TWI_ISTAT_TXSERV;
	}

    while(!(*pREG_TWI0_ISTAT & BITM_TWI_ISTAT_MCOMP));
	*pREG_TWI0_ISTAT |= 	BITM_TWI_ISTAT_TXSERV | BITM_TWI_ISTAT_MCOMP;
}
/*=============================================================================================================================*/

void Read_TWI_8bit_Reg(unsigned char CHIP_ID, unsigned char Reg_ID, unsigned char* Rx_Buff, unsigned char count)
{
	*pREG_TWI0_MSTRADDR = CHIP_ID;
	unsigned char i, temp_data;
	*pREG_TWI0_TXDATA8 = 	(Reg_ID & 0xFF);
	*pREG_TWI0_MSTRCTL =    (1 << 6) | ENUM_TWI_MSTRCTL_RPT | ENUM_TWI_MSTRCTL_TX | BITM_TWI_MSTRCTL_EN;
	while(!(*pREG_TWI0_ISTAT & BITM_TWI_ISTAT_MCOMP));
	*pREG_TWI0_ISTAT |= 	BITM_TWI_ISTAT_TXSERV | BITM_TWI_ISTAT_MCOMP;

	*pREG_TWI0_MSTRCTL =    (count << 6) | ENUM_TWI_MSTRCTL_RX | BITM_TWI_MSTRCTL_EN;
	for(i=0; i<(count); i++)
	{
		while(!(*pREG_TWI0_ISTAT &	BITM_TWI_ISTAT_RXSERV));
		 *Rx_Buff++ = (*pREG_TWI0_RXDATA8 & 0xFF);
		*pREG_TWI0_ISTAT |=	BITM_TWI_ISTAT_RXSERV;
	}

    while(!(*pREG_TWI0_ISTAT & BITM_TWI_ISTAT_MCOMP));
	*pREG_TWI0_ISTAT |= BITM_TWI_ISTAT_RXSERV | BITM_TWI_ISTAT_MCOMP;
}

void Wait_For_Completion(void)
{
	while(!(*pREG_TWI0_ISTAT &	BITM_TWI_ISTAT_MCOMP));
	*pREG_TWI0_ISTAT |= 	BITM_TWI_ISTAT_TXSERV | BITM_TWI_ISTAT_MCOMP;
}
/***************************************************************************************************************************/
